Tasks = LibStub("AceAddon-3.0"):NewAddon("Tasks", "AceConsole-3.0", "AceEvent-3.0")
Tasks.L = LibStub("AceLocale-3.0"):GetLocale("Tasks", false)
TasksUtils = {}


function Tasks:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("TasksDB", self.defaults["db"], true)
  self:CheckDBVersion()
  
  --initialize various modules
  self:ConfigInit()
  self:UtilsInit()
  self:TemplatesInit()
  self:DisplayInit()
  self:EngineInit()
  
  --retrieve and store character info
  local char = UnitName("player") .. " - " .. GetRealmName()
  -- local char =  GetUnitName("player", true")
  self.currentCharacter = char
  self.db.global.characters[char].name = UnitName("player")
  self.db.global.characters[char].realm = GetRealmName()
  self.db.global.characters[char].class = select(2,UnitClass("player"))
  self.db.global.characters[char].level = UnitLevel("player")
  self.db.global.characters[char].race = select(2, UnitRace("player"))
  self.db.global.characters[char].faction = UnitFactionGroup("player")

end

function Tasks:OnEnable()
end

function Tasks:OnDisable()

end

function Tasks:CheckDBVersion()
  if not(self.db.global.dbVersion) then
    self.db.global.dbVersion = self.constants.CURRENT_DB_VERSION
  end
  
  if(self.db.global.dbVersion == 1) then
    self.db.global.encounters = nil
    self.db.global.dbVersion = 2
  end
end